package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.text.TextField;
	import flash.utils.getTimer;
	
	[SWF(width="800", height="600")]
	public class TailCallTest extends Sprite
	{
		public function TailCallTest()
		{
			loaderInfo.addEventListener(Event.INIT, initHandler);
		}
		
		public function initHandler(event:Event):void
		{
			var tf:TextField = new TextField();
			addChild(tf);
			tf.width = stage.stageWidth;
			tf.height = stage.stageHeight;
			tf.multiline=true;
			
			var log:String = "";
			var s:String;
			var i:int;
			var n:int = 1000000;
			var t:Number = getTimer();
			for (i = 0; i < n; i++)
			{
				s = _foo;
			}
			log += "1. read from a var " + (getTimer() - t).toString() + "\n";

			t = getTimer();
			for (i = 0; i < n; i++)
			{
				s = someMethod();
			}
			log += "2. call a method to read from a var " + (getTimer() - t).toString() + "\n";
			log += "     essentially the cost of an extra function call\n";

			t = getTimer();
			for (i = 0; i < n; i++)
			{
				s = someMethod2();
			}
			log += "3. call a method that calls a method to read from a var " + (getTimer() - t).toString() + "\n";
			log += "     essentially the cost of two extra function calls\n";
		
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				s = someMethod3();
			}
			log += "4. attempt to simulate overhead for a tail call optimization of the prior scenario " + (getTimer() - t).toString() + "\n";
			tf.text = log;
			
			var oc:OriginalClass = new OriginalClass();
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				var j:Number = oc.someMethod();
			}
			log += "5. call a method in another class that adds two vars and returns the result " + (getTimer() - t).toString() + "\n";
			tf.text = log;
			
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				var p:Number = oc.someMethodGetSet();
			}
			log += "6. call a method in another class that adds two vars fetched via getters and returns the result " + (getTimer() - t).toString() + "\n";
			tf.text = log;
			
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				oc.someMethod2(oc.var1, oc.var2);
			}
			log += "7. call a method in another class that takes two values fetched via getters from that class and stores them as vars " + (getTimer() - t).toString() + "\n";
			tf.text = log;
			
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				oc.someMethod2GetSet(oc.var1, oc.var2);
			}
			log += "8. call a method in another class that takes two values fetched via getters from that class and stores them via setters " + (getTimer() - t).toString() + "\n";
			tf.text = log;
			
			var ph:PlugInHost = new PlugInHost();
			ph.plugIns["IPlugIn"] = new PlugIn(ph);
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				var k:Number = ph.someMethod();
			}
			log += "9. scenario #5 with plugins " + (getTimer() - t).toString() + "\n";
			log += "     basically, lots of extra function calls\n";
			tf.text = log;
			
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				ph.someMethod2(ph.var1, ph.var2);
			}
			log += "10. scenario #7 with plugins " + (getTimer() - t).toString() + "\n";
			log += "      again, lots of extra function calls\n";
			tf.text = log;
			
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				var m:Number = ph.someMethodTail();
			}
			log += "11. scenario #5 with attempt to simulate overhead of tail call optimization " + (getTimer() - t).toString() + "\n";
			log += "      overhead reduced closer to the speed of scenario #6\n";
			tf.text = log;
			
			t = getTimer();
			for (i = 0; i < n; i++)
			{
				// call the host.var1 getter
				jump1: {
					break jump1;
				}
				// call the plugIn.var1 getter
				jump2: {
					break jump2;
				}
				// call the host.var2 getter
				jump1: {
					break jump1;
				}
				// call the plugIn.var2 getter
				jump2: {
					break jump2;
				}				
				ph.someMethodTail2(PlugIn(ph.plugIns["IPlugIn"])._var1, 
					PlugIn(ph.plugIns["IPlugIn"])._var2);
			}
			log += "12. scenario #7 with attempt to simulate overhead of tail call optimization " + (getTimer() - t).toString() + "\n";
			log += "      overhead reduced closer to the speed of scenario #8\n";
			tf.text = log;
		}
		
		private var _foo:String = "foo";
		
		public function someMethod():String
		{
			return _foo;
		}
		
		public function someMethod2():String
		{
			return someMethod();
		}
		
		public function someMethod3():String
		{
			shortcut: {
				break shortcut;
			}
			return _foo;
		}
			

	}
}